---
title: 'WebGLRenderingContext.uniform[1234][fi][v]()'
slug: Web/API/WebGLRenderingContext/uniform
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.uniform[1234][fi][v]()</code></strong> methods of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> specify values of uniform variables. All active uniform variables defined in a program object are initialized to 0 when the program object is linked successfully. They retain the values assigned to them by a call to this method until the next successful link operation occurs on the program object, when they are once again initialized to 0.</p>

<div class="note">
<p>Many of the functions described here have expanded WebGL 2 interfaces, which can be found under {{domxref("WebGL2RenderingContext.uniform","WebGL2RenderingContext.uniform[1234][uif][v]()")}}.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">void <var>gl</var>.uniform1f(<var>location</var>, <var>v0</var>);
void <var>gl</var>.uniform1fv(<var>location</var>, <var>value</var>);
void <var>gl</var>.uniform1i(<var>location</var>, <var>v0</var>);
void <var>gl</var>.uniform1iv(<var>location</var>, <var>value</var>);

void <var>gl</var>.uniform2f(<var>location</var>, <var>v0</var>, <var>v1</var>);
void <var>gl</var>.uniform2fv(<var>location</var>, <var>value</var>);
void <var>gl</var>.uniform2i(<var>location</var>, <var>v0</var>, <var>v1</var>);
void <var>gl</var>.uniform2iv(<var>location</var>, <var>value</var>);

void <var>gl</var>.uniform3f(<var>location</var>, <var>v0</var>, <var>v1</var>, <var>v2</var>);
void <var>gl</var>.uniform3fv(<var>location</var>, <var>value</var>);
void <var>gl</var>.uniform3i(<var>location</var>, <var>v0</var>, <var>v1</var>, <var>v2</var>);
void <var>gl</var>.uniform3iv(<var>location</var>, <var>value</var>);

void <var>gl</var>.uniform4f(<var>location</var>, <var>v0</var>, <var>v1</var>, <var>v2</var>, <var>v3</var>);
void <var>gl</var>.uniform4fv(<var>location</var>, <var>value</var>);
void <var>gl</var>.uniform4i(<var>location</var>, <var>v0</var>, <var>v1</var>, <var>v2</var>, <var>v3</var>);
void <var>gl</var>.uniform4iv(<var>location</var>, <var>value</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>location</dt>
 <dd>A {{domxref("WebGLUniformLocation")}} object containing the location of the uniform attribute to modify.</dd>
 <dt><code>value, v0, v1, v2, v3</code></dt>
 <dd>A new value to be used for the uniform variable. Possible types:
 <ul>
  <li>A floating point {{jsxref("Number")}} for floating point values (methods with "f").</li>
  <li>A sequence of floating point numbers (for example a {{jsxref("Float32Array")}} or an {{jsxref("Array")}} of numbers) for floating point vector methods (methods with "fv").</li>
  <li>An integer {{jsxref("Number")}} for integer values (methods with "i").</li>
  <li>An {{jsxref("Int32Array")}} for integer vector methods (methods with "iv").</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js notranslate">gl.uniform1f(u_alpha, 0.8);</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.10", "uniform")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glUniform.xml", "glUniform")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Main page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.uniform1f")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.uniformMatrix()")}}</li>
</ul>
